// Objectname = camera
// Objecttype = view


camera
{
    location  <-0.330747,38.7344,196.173>
    sky       <-3.15828e-06,0.00294261,-0.000584023>
    look_at    <-0.329093,38.5397,195.193>
    up         <-6.31656e-06,0.00588522,-0.00116805>
    right      <-0.00600001,-8.12734e-06,-8.50294e-06>
}

// Global settings
global_settings
{
    ambient_light rgb<5,5,5>
    assumed_gamma 2.2
}


// Objectname = World
// Objecttype = world


// Objectname = Surrounding
// Objecttype = csg (union)
union
{
    // Objectname = Wall
    // Objecttype = plane
    plane
    {
        < 0, 1, 0>, 0
        // Objectname = Checker
        // Objecttype = texture
        pigment
        {
            checker color rgb<1,1,1> color rgb<0,0,0>
        }
        finish
        {
            ambient          rgb<2,2,2>
        }
        scale     <0.25,0.25,0.25>
        rotate    <90,0,0>
        translate <0,1,0>
    }
    // Objectname = Floor
    // Objecttype = plane
    plane
    {
        < 0, 1, 0>, 0
        // Objectname = Checker
        // Objecttype = texture
        pigment
        {
            checker color rgb<1,1,1> color rgb<0,0,0>
        }
        finish
        {
            ambient          rgb<2,2,2>
        }
        scale     <0.25,0.25,0.25>
        rotate    <0,0,0>
        translate <0,0,0>
    }
    scale     <1,1,1>
    rotate    <0,0,0>
    translate <0,-0.5,0>
}
// Objectname = Sphere
// Objecttype = sphere
sphere
{
    <0,0,0>,0.5
    // Objectname = Texture
    // Objecttype = texture

    #include "texture.pov"

    scale     <1,1,1>
    rotate    <0,0,0>
    translate <0,0,1>
}

// Objectname = Lightpoint
// Objecttype = lightpoint
light_source
{
    <0, 0, 0>
    color rgb<1.000000, 1.000000, 1.000000> 
    fade_distance 0.000000 
    fade_power 0.000000 
    scale     <1,1,1>
    rotate    <0,0,0>
    translate <0,2,0>
}

// Objectname = Lightpoint1
// Objecttype = lightpoint
light_source
{
    <0, 0, 0>
    color rgb<1.000000, 1.000000, 1.000000> 
    fade_distance 0.000000 
    fade_power 0.000000 
    scale     <1,1,1>
    rotate    <0,0,0>
    translate <0,1,1>
}

// Objectname = Lightpoint2
// Objecttype = lightpoint
light_source
{
    <0, 0, 0>
    color rgb<1.000000, 1.000000, 1.000000> 
    fade_distance 0.000000 
    fade_power 0.000000 
    scale     <1,1,1>
    rotate    <0,0,0>
    translate <0,0,3>
}

