/******************************************************************************
**                                                                           **
**    k4de - 3d-editor for the K Desktop Enviroment                          **
**                                                                           **
**    Copyright (C) 1999  Tobias Wollgam (tobias.wollgam@gmx.de)             **
**    Copyright (C) 1999  Markus Weber (mweber@gmx.de)                       **
**                                                                           **
**    This program is free software; you can redistribute it and/or modify   **
**    it under the terms of the GNU General Public License as published by   **
**    the Free Software Foundation; either version 2 of the License, or      **
**    (at your option) any later version.                                    **
**                                                                           **
**    This program is distributed in the hope that it will be useful,        **
**    but WITHOUT ANY WARRANTY; without even the implied warranty of         **
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          **
**    GNU General Public License for more details.                           **
**                                                                           **
**    You should have received a copy of the GNU General Public License      **
**    along with this program; if not, write to the Free Software            **
**    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              **
**                                                                           **
******************************************************************************/
/*
** ear.h
*/
#ifndef __EAR_H__
#define __EAR_H__

#include <classes.h>

class ear : public body
{
protected:
	unsigned int	channel;

public:
	ear(base *p = 0,const char *n="Untitled",unsigned int c = 0);
	ear(base *p,ear*);
	~ear();

	void		setChannel(unsigned int);
	unsigned int	getChannel();
	
	virtual int	addToParent(base*);
	virtual int	removeFromParent();

	virtual base	*copy(base *parent);

	virtual int	exportPOV(FILE*,int tab,int tabsize,int anim = 0);

	virtual void	dumpNames(int tab,int tabsize);

	virtual int	save(media*,int);
	virtual int	load(media*,int,int);

	virtual int	calculate(int anim);
	virtual int	draw(view*,Matrix44,int);

	virtual double	volume(int);
};

#endif


