/******************************************************************************
**                                                                           **
**    k4de - 3d-editor for the K Desktop Enviroment                          **
**                                                                           **
**    Copyright (C) 1999  Tobias Wollgam (tobias.wollgam@gmx.de)             **
**    Copyright (C) 1999  Markus Weber (mweber@gmx.de)                       **
**                                                                           **
**    This program is free software; you can redistribute it and/or modify   **
**    it under the terms of the GNU General Public License as published by   **
**    the Free Software Foundation; either version 2 of the License, or      **
**    (at your option) any later version.                                    **
**                                                                           **
**    This program is distributed in the hope that it will be useful,        **
**    but WITHOUT ANY WARRANTY; without even the implied warranty of         **
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          **
**    GNU General Public License for more details.                           **
**                                                                           **
**    You should have received a copy of the GNU General Public License      **
**    along with this program; if not, write to the Free Software            **
**    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              **
**                                                                           **
******************************************************************************/
/*
** cubic.h
*/
#ifndef __CUBIC_H__
#define __CUBIC_H__

#include <stdio.h>

#include <classes.h>


class cubic : public csgobj
{
protected:
	int	count;
	double	koeff[20]; 

public:
	cubic(base *b=0, char *n="Untitled");
	~cubic();

	int		addKoeff(double k);
	int		reset();
	
	virtual int	addToParent(base *p);
	virtual void	dumpNames(int,int);

	virtual int	exportPOV(FILE *, int, int,int anim = 0);
	virtual int	save(FILE *);
	virtual int	load(FILE *,int);
};

#endif
