/******************************************************************************
**                                                                           **
**    k4de - 3d-editor for the K Desktop Enviroment                          **
**                                                                           **
**    Copyright (C) 1999  Tobias Wollgam (tobias.wollgam@gmx.de)             **
**    Copyright (C) 1999  Markus Weber (mweber@gmx.de)                       **
**                                                                           **
**    This program is free software; you can redistribute it and/or modify   **
**    it under the terms of the GNU General Public License as published by   **
**    the Free Software Foundation; either version 2 of the License, or      **
**    (at your option) any later version.                                    **
**                                                                           **
**    This program is distributed in the hope that it will be useful,        **
**    but WITHOUT ANY WARRANTY; without even the implied warranty of         **
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          **
**    GNU General Public License for more details.                           **
**                                                                           **
**    You should have received a copy of the GNU General Public License      **
**    along with this program; if not, write to the Free Software            **
**    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              **
**                                                                           **
******************************************************************************/
/*
** texturebook.h
*/
#ifndef __TextureBook_H__
#define __TextureBook_H__

#include <chunk.h>
#include <list.h>
#include "texture.h"

class TextureBook :public textureBase
{

protected:
public:

	TextureBook(textureBase *p=NULL);
	~TextureBook();

	bool exists(char *);

	void add(textureBase*);
	bool canAdd(textureBase *);
	void addElement(textureBase*,textureBase *);

	texture *findTexturePath(const char *n);

	textureBase *findTexture(const char*);
	textureBase *findTextureStruct(texture*);
	
	int	load(media*,int);
	int	save(media*);

	int exportPOV(FILE*,int,int,int,bool);

};


#endif


