/******************************************************************************
**                                                                           **
**    k4de - 3d-editor for the K Desktop Enviroment                          **
**                                                                           **
**    Copyright (C) 1999  Tobias Wollgam (tobias.wollgam@gmx.de)             **
**    Copyright (C) 1999  Markus Weber (mweber@gmx.de)                       **
**                                                                           **
**    This program is free software; you can redistribute it and/or modify   **
**    it under the terms of the GNU General Public License as published by   **
**    the Free Software Foundation; either version 2 of the License, or      **
**    (at your option) any later version.                                    **
**                                                                           **
**    This program is distributed in the hope that it will be useful,        **
**    but WITHOUT ANY WARRANTY; without even the implied warranty of         **
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          **
**    GNU General Public License for more details.                           **
**                                                                           **
**    You should have received a copy of the GNU General Public License      **
**    along with this program; if not, write to the Free Software            **
**    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              **
**                                                                           **
******************************************************************************/
/*
** transformations.h
*/
#ifndef __TRANSFORMATIONS_H__
#define __TRANSFORMATIONS_H__

#include <misc.h>
#include <list.h>
#include <chunk.h>
#include <stdio.h>


#include "texturebase.h"

class Transformations:public textureBase
{
protected:

	Vector3 scale,rotate,translate;
	void updateInfo();	

public:

	Transformations(textureBase *p=NULL);	
	~Transformations();
	
	void setScaling(Vector3);
	Vector3 getScaling();

	void setTranslation(Vector3);
	Vector3 getTranslation();

	void setRotation(Vector3);
	Vector3 getRotation();

	bool	isEqual(textureBase *);
	const char **getXPM();
	bool	canAdd(textureBase *);
	void	add(textureBase *);

	int	save(media*);
	int	load(media*,int);

	int	exportPOV(FILE*,int,int, int,bool);
};

#endif
