/******************************************************************************
**                                                                           **
**    k4de - 3d-editor for the K Desktop Enviroment                          **
**                                                                           **
**    Copyright (C) 1999  Tobias Wollgam (tobias.wollgam@gmx.de)             **
**    Copyright (C) 1999  Markus Weber (mweber@gmx.de)                       **
**                                                                           **
**    This program is free software; you can redistribute it and/or modify   **
**    it under the terms of the GNU General Public License as published by   **
**    the Free Software Foundation; either version 2 of the License, or      **
**    (at your option) any later version.                                    **
**                                                                           **
**    This program is distributed in the hope that it will be useful,        **
**    but WITHOUT ANY WARRANTY; without even the implied warranty of         **
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          **
**    GNU General Public License for more details.                           **
**                                                                           **
**    You should have received a copy of the GNU General Public License      **
**    along with this program; if not, write to the Free Software            **
**    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              **
**                                                                           **
******************************************************************************/
/*
** df3wizard.h
*/
#ifndef __DF3WIZARD_H__
#define __DF3WIZARD_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <qwidget.h>
#include <qlabel.h> 
#include <qpushbutton.h>
#include <qdialog.h>
#include <qcolor.h>
#include <qimage.h>
#include <qpainter.h>
#include "../widgets/getfilewidget.h"
#include "../widgets/vectorwidget.h"
#include "../widgets/spinbox.h"

class	 df3Wizard: QDialog
{
Q_OBJECT
protected:
	QPushButton		*ok,*cancel,*invert;

	GetFileWidget   	*source1,*source2,*dest;
	SpinBox			*depth;
	VectorWidget		*sizeWidget;
	Vector3			*size;
	QFrame			*previewA,*previewB;
	QImage			*picA,*picB;
	QPainter		*painterA,*painterB;

public:
	df3Wizard(QWidget *parent,char *name="");
	~df3Wizard();
	
	void exec();

public slots:
	void paintEvent(QPaintEvent *);


protected slots:
	void okayPressed();
	void cancelPressed();
	void invertPressed();
	void newSource1();
	void newSource2();

};


#endif

