/******************************************************************************
**                                                                           **
**    k4de - 3d-editor for the K Desktop Enviroment                          **
**                                                                           **
**    Copyright (C) 1999  Tobias Wollgam (tobias.wollgam@gmx.de)             **
**    Copyright (C) 1999  Markus Weber (mweber@gmx.de)                       **
**                                                                           **
**    This program is free software; you can redistribute it and/or modify   **
**    it under the terms of the GNU General Public License as published by   **
**    the Free Software Foundation; either version 2 of the License, or      **
**    (at your option) any later version.                                    **
**                                                                           **
**    This program is distributed in the hope that it will be useful,        **
**    but WITHOUT ANY WARRANTY; without even the implied warranty of         **
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          **
**    GNU General Public License for more details.                           **
**                                                                           **
**    You should have received a copy of the GNU General Public License      **
**    along with this program; if not, write to the Free Software            **
**    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              **
**                                                                           **
******************************************************************************/
/*
** transformdialog.h
*/
#ifndef __TRANSFORMDIALOG_H__
#define __TRANSFORMDIALOG_H__


#include <qdialog.h>
#include <qlineedit.h> 
#include <qlabel.h> 
#include <qpushbutton.h>


#include "../widgets/transformwidget.h"

class	TransformDialog : public QDialog
{
Q_OBJECT

protected:
	QPushButton	*ok,*cancel;
	TransformWidget	*tfw;
	
	Vector3		*vscale,*vrotate,*vtranslate;
	Vector3		vscalesv,vrotatesv,vtranslatesv;

public:
	TransformDialog(QWidget *parent,const char *name,Vector3 *vs,Vector3 *vr,Vector3 *vt);
	~TransformDialog();

public slots:
	void	saveData();
	void	loadData();
	
signals:
	void	changedData();
	
protected:
	void	layout();
	
protected slots:
	void	restoreValues();
};


#endif

