/******************************************************************************
**                                                                           **
**    k4de - 3d-editor for the K Desktop Enviroment                          **
**                                                                           **
**    Copyright (C) 1999  Tobias Wollgam (tobias.wollgam@gmx.de)             **
**    Copyright (C) 1999  Markus Weber (mweber@gmx.de)                       **
**                                                                           **
**    This program is free software; you can redistribute it and/or modify   **
**    it under the terms of the GNU General Public License as published by   **
**    the Free Software Foundation; either version 2 of the License, or      **
**    (at your option) any later version.                                    **
**                                                                           **
**    This program is distributed in the hope that it will be useful,        **
**    but WITHOUT ANY WARRANTY; without even the implied warranty of         **
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          **
**    GNU General Public License for more details.                           **
**                                                                           **
**    You should have received a copy of the GNU General Public License      **
**    along with this program; if not, write to the Free Software            **
**    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              **
**                                                                           **
******************************************************************************/
/*
** font.h
*/
#ifndef __FONT_H__
#define __FONT_H__

#include "glyph.h"

#include <freetype.h>

class font
{
protected:
	char			*name;
	char			*filename;
	char			*pathname;

	TT_Face			face;
	bool			face_valid;
        TT_Face_Properties	properties;

	fontglyph		**glyphcache;

public:
	font(const char *n,const char *fn = 0,const char *pn = 0);
	font(font&);

	~font();

	fontglyph	*getGlyph(char *);
	fontglyph	*getGlyph(char c);

	void		setFileName(char*);
	char		*getFileName();

private:
	int		initialize();
	void		destroy();

	fontglyph	*getCachedGlyph(char*);
	void		cacheGlyph(fontglyph *g);
};

#endif

